Subject: Re: [PATCH net-next] macvlan: pass get_ts_info and SIOC[SG]HWTSTAMP ioctl to real device

From: Miroslav Lichvar <[email-masked]>
Date: Tue, 23 Apr 2019 10:31:41 +0200

On Tue, Apr 23, 2019 at 12:18:17PM +0800, Hangbin Liu wrote:
> On Thu, Apr 18, 2019 at 10:05:09AM +0200, Miroslav Lichvar wrote:
> > select a more general filter. A container could run a PTP clock if it
> 
> Do you have an idea about how to select a general filter? If we have enabled
> HWTSTAMP_FILTER_PTP_V2_L4_SYNC on host and a user in container want to enable
> HWTSTAMP_FILTER_PTP_V2_L4_DELAY_REQ, then which one is more general?

In this case neither is a more general filter of the other. If
V2_L4_SYNC is already selected, only the following filters could be
selected on the macvlan interface:

	HWTSTAMP_FILTER_PTP_V2_L4_SYNC,
	HWTSTAMP_FILTER_PTP_V2_L4_EVENT,
	HWTSTAMP_FILTER_PTP_V2_SYNC,
	HWTSTAMP_FILTER_PTP_V2_EVENT,
	HWTSTAMP_FILTER_ALL,

I think one way to check this would be to assign each filter a
(16-bit?) value where the individual bits correspond to the message
types and the newly selected filter would have to contain all bits of
the old one.

> > If I understand it correctly, even without this ioctl a container can
> > prevent the host or other containers from getting some of the HW
> > timestamps by requesting TX timestamps at a high rate. I suspect the
> 
> Could traffic sharping/limitation fix it?

Yes, but it has to be specific to packets with TX timestamp requested.
>From what I have seen, TX timestamping may start to fail at just few
tens of thousands of packets per second.

-- 
Miroslav Lichvar